/*
 * Copyright (C) 2010-2012 Agrosense info@agrosense.eu
 * 
 * Licensed under the Eclipse Public License - v 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *          http://www.eclipse.org/legal/epl-v10.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package nl.cloudfarming.client.stock.crop;

import nl.cloudfarming.client.crop.model.CropDefinition;
import org.openide.explorer.ExplorerManager;
import org.openide.nodes.Node;
import org.openide.nodes.PropertySupport;
import org.openide.util.Exceptions;

/**
 *
 * @author Timon Veenstra <monezz@gmail.com>
 */
public class CropListVisualPanel extends javax.swing.JPanel implements ExplorerManager.Provider{

    private final CropStorage cropStorage;

    /**
     * Creates new form CropListVisualPanel
     */
    public CropListVisualPanel(CropStorage cropStorage) {
        this.cropStorage = cropStorage;
//        this.definitions = cropStorage.getCropDefinitions();
        initComponents();
        try {
            Node.Property name = new PropertySupport.Reflection(new CropDefinition(""), String.class, "name");
            Node.Property source = new PropertySupport.Reflection(new CropDefinition(""), String.class, "getSource",null);
            treeTableView1.setProperties(new Node.Property[]{name,source});
            treeTableView1.setRootVisible(false);
            
    //        Node.Property[] properties = new Node.Property[WIDTH];
    //        properties[0] = new PropertySupport.Name(Node.EMPTY);
    //        treeTableView1.setProperties(properties);

            
    //        listTableView1.setRootVisible(false);

    //        setLayout(new BorderLayout());
    //        BeanTreeView beanTreeView = new BeanTreeView();
    //        beanTreeView.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    //        beanTreeView.setPreferredSize(new Dimension(300, 300));
    //        add(beanTreeView, BorderLayout.CENTER);
    //        masterTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    //        masterTable.setColumnControlVisible(true);
    //        
    //        varietyTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    //        varietyTable.setColumnControlVisible(true);
    //
    //        masterTable.getSelectionModel().addListSelectionListener(varietyTable);
    //        bindingGroup.getBinding("varietyMasterSelectionBinding").;
        } catch (NoSuchMethodException ex) {
            Exceptions.printStackTrace(ex);
        }

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        treeTableView1 = new org.openide.explorer.view.TreeTableView();

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(treeTableView1, javax.swing.GroupLayout.DEFAULT_SIZE, 469, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(treeTableView1, javax.swing.GroupLayout.DEFAULT_SIZE, 413, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.openide.explorer.view.TreeTableView treeTableView1;
    // End of variables declaration//GEN-END:variables

    @Override
    public ExplorerManager getExplorerManager() {
        return cropStorage.getExplorerManager();
    }
}
